#include <stdio.h>

#ifdef sun
#ifdef _bufsiz
#define SOLARIS
#endif
#endif

#include <sys/types.h>
#include <utmp.h>

char *getenv();
char *ttyname();

#define USRLOG ".peru/"

get_ut_host(utmp,buff,leng)
	struct utmp *utmp;
	char *buff;
{
#ifdef SOLARIS
	strcpy(buff,"");
#else
	strncpy(buff,utmp->ut_host,sizeof(utmp->ut_host));
#endif
}
set_ut_host(utmp,buff,leng)
	struct utmp *utmp;
	char *buff;
{
#ifdef SOLARIS
#else
	strncpy(utmp->ut_host,buff,sizeof(utmp->ut_host));
#endif
}

static
add_utmp0( logfile,utmp )
	struct utmp *utmp;
{	FILE *fp;

	fp = fopen(logfile,"a"); 
	if( fp != NULL ){
		fwrite(utmp,sizeof(struct utmp),1,fp);
		fclose(fp);
	}
}

#define	LOGIN	1
#define	LOGOUT	2
#define	ABORT	3

static struct utmp utmp,iutmp;

static
add_utmp( logfile,type, line,user,host,ctime )
	char *line,*user,*host;
{	char Name[100];
	char path[1024];

	switch( type ){
		default:	return;
		case LOGIN:	strcpy(Name,user); break;
		case LOGOUT:	*Name = 0; break;
		case ABORT:	sprintf(Name,"~%s",user); break;
	}

	utmp = iutmp;
	strncpy(utmp.ut_line,line,sizeof(utmp.ut_line));
	strncpy(utmp.ut_name,Name,sizeof(utmp.ut_name));
	set_ut_host(&utmp,host);
	utmp.ut_time = ctime ? ctime : time(0);

	if( strcmp(user,"?") != 0 )
		add_utmp0(logfile,&utmp);

	/* per user log */
	sprintf(path,"%s%s%s",logfile,USRLOG,user);
	add_utmp0(path,&utmp);
}

add_logout( logfile,line,host,ctime )
{
	add_utmp(logfile,LOGOUT, line,"",host,ctime);
}

set_utmp( utmp )
	struct utmp *utmp;
{	char *line,*name,host[100];

	line = ttyname(0);
	name = getenv("USER");
	gethostname(host,sizeof(host));

	*utmp = iutmp;
	strncpy(utmp->ut_line,line,sizeof(utmp->ut_line));
	strncpy(utmp->ut_name,name,sizeof(utmp->ut_name));
	set_ut_host(&utmp,host);
	utmp->ut_time = time(0);
}

sprint_xutmp(urec,command)
	char *urec;
{	char *user,*line,*term;
	char host[128];

	if((user = getenv("USER")) == 0 )	user = "?";
	if((line = ttyname(0)) == 0 )		line = "?";
	if((term = getenv("TERM")) == 0 )	term = "?";
	if( gethostname(host,sizeof(host)) != 0 )
		sprintf(host,"%x",gethostid());

	sprintf(urec,"COMD=%s USER=%s LINE=%s TERM=%s HOST=%s TIME=%d",
		command,user,line,term,host,time(0));
}

add_xutmp(logfile,type,urec)
	char *logfile,*type,*urec;
{	char command[100],user[100],line[100],term[100],host[100];
	int ctime;
	int Type;
	char Line[100],Host[100];

	if( strcmp(type,"LOGIN") == 0 ) Type = LOGIN;  else
	if( strcmp(type,"LOGOUT")== 0 ) Type = LOGOUT; else
	if( strcmp(type,"ABORT") == 0 ) Type = ABORT;  else
		return -1;

	command[0] = user[0] = line[0] = term[0] = host[0] = 0;
	sscanf(urec,"COMD=%s USER=%s LINE=%s TERM=%s HOST=%s TIME=%d",
		command,user,line,term,host,&ctime);
	ctime = time(0);

	if( strncmp(line,"/dev/",5) == 0 )
		strcpy(line,line+5);
	if( strncmp(line,"tty",3)==0 || strncmp(line,"pty",3)==0 )
		strcpy(line,line+3);
	sprintf(Line,"%-5d %s",getpid(),line);
	sprintf(Host,"%-6s %s %s",host,command,term);

	add_utmp(logfile,Type, Line,user,Host,ctime);
	return 0;
}
